﻿using System;
using System.Collections.Generic;
using System.Collections.ObjectModel;
using System.Linq;
using System.Text;
using System.Windows;
using System.Windows.Controls;
using System.Windows.Data;
using System.Windows.Documents;
using System.Windows.Input;
using System.Windows.Media;
using System.Windows.Media.Imaging;
using System.Windows.Navigation;
using System.Windows.Shapes;

namespace DataGridSample
{
    public partial class DataGridView : UserControl
    {
        public DataGridView()
        {
            InitializeComponent();

            DataContext = new DataGridViewModel();
            
        }
        private void Button_Click(object sender, RoutedEventArgs e)
        {
            var grid = (VisualTreeHelpers.FindChild<C1.WPF.DataGrid.C1DataGrid>(this, "myGrid") as C1.WPF.DataGrid.C1DataGrid);
            //  grid.GroupBy(grid.Columns["Age"]);
            ObservableCollection<RecordInfo> selRcrds = new ObservableCollection<RecordInfo>();
            foreach(RecordInfo s in grid.SelectedItems)
            {
                selRcrds.Add(s);
            }
            for(int i =0;i< selRcrds.Count;i++)
            {
                MessageBox.Show("Name:"+ selRcrds[i].Name + " Age:"+ selRcrds[i].Age + " DOB:"+ selRcrds[i].DateOfBirth + " Address:"+ selRcrds[i].Address + "\n");
            }
        }
    }
    public class VisualTreeHelpers
    {
        // Looks for a child control within a parent by name
        public static T FindChild<T>(DependencyObject parent, string childName)
        where T : DependencyObject
        {
            if (parent == null) return null;

            T _foundChild = null;

            int childrenCount = VisualTreeHelper.GetChildrenCount(parent);
            for (int i = 0; i < childrenCount; i++)
            {
                var child = VisualTreeHelper.GetChild(parent, i);
                // If the child is not of the request child type child
                T childType = child as T;
                if (childType == null)
                {
                    // recursively drill down the tree
                    _foundChild = FindChild<T>(child, childName);

                    // If the child is found, break so we do not overwrite the found child.
                    if (_foundChild != null) break;
                }
                else if (!string.IsNullOrEmpty(childName))
                {
                    var frameworkElement = child as FrameworkElement;
                    if (frameworkElement != null && frameworkElement.Name == childName)
                    {
                        // if the name of child is same to that of request -> break
                        _foundChild = (T)child;
                        break;
                    }
                    else
                    {
                        // recursively traverse down the tree
                         _foundChild = FindChild<T>(child, childName);

                        // if child is found -> break
                        if (_foundChild != null) break;
                    }
                }
                else
                {
                    // child element found.
                    _foundChild = (T)child;
                    break;
                }
            }

            return _foundChild;
        }

        /// <summary>
        /// Looks for a child control within a parent by type
        /// </summary>
        public static T FindChild<T>(DependencyObject parent)
            where T : DependencyObject
        {
            // Confirm parent is valid.
            if (parent == null) return null;

            T foundChild = null;

            int childrenCount = VisualTreeHelper.GetChildrenCount(parent);
            for (int i = 0; i < childrenCount; i++)
            {
                var child = VisualTreeHelper.GetChild(parent, i);
                // If the child is not of the request child type child
                T childType = child as T;
                if (childType == null)
                {
                    // recursively drill down the tree
                    foundChild = FindChild<T>(child);

                    // If the child is found, break so we do not overwrite the found child.
                    if (foundChild != null) break;
                }
                else
                {
                    // child element found.
                    foundChild = (T)child;
                    break;
                }
            }
            return foundChild;
        }
    }
}
