﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Windows.Input;
using System.Collections.ObjectModel;
using System.ComponentModel;

namespace DataGridSample
{
    public class DataGridViewModel :ViewModelBase
    {
        ObservableCollection<RecordInfo> infos;
        ICommand _command;

        public DataGridViewModel()
        {
            PersonsInfo = new ObservableCollection<RecordInfo>();

            PersonsInfo.Add(new RecordInfo { Name = "AA", Age = 24, DateOfBirth = new DateTime(1987, 4, 29),Address="XXX XXX XXXX" });
            PersonsInfo.Add(new RecordInfo { Name = "BB", Age = 23, DateOfBirth = new DateTime(1988, 3, 4),Address="XXX XXXXX XXX" });
            PersonsInfo.Add(new RecordInfo { Name = "CC", Age = 26, DateOfBirth = new DateTime(1985, 10, 2),Address="XXX XXX X" });
            PersonsInfo.Add(new RecordInfo { Name = "DD", Age = 28, DateOfBirth = new DateTime(1983, 5, 7),Address="XX XXXXX XX" });
            PersonsInfo.Add(new RecordInfo { Name = "EE", Age = 26, DateOfBirth = new DateTime(1985, 11, 20),Address="XXXX XXXXX XXX" });
            PersonsInfo.Add(new RecordInfo { Name = "FF", Age = 22, DateOfBirth = new DateTime(1989, 1, 27),Address="XXXXXXXXXXX XX" });
            PersonsInfo.Add(new RecordInfo { Name = "GG", Age = 21, DateOfBirth = new DateTime(1990, 8, 6),Address="XXX XXXX XXXXXX" });
            PersonsInfo.Add(new RecordInfo { Name = "HH", Age = 23, DateOfBirth = new DateTime(1988, 9, 9),Address="XX XXXXXXXXX XXX" });
            PersonsInfo.Add(new RecordInfo { Name = "II", Age = 24, DateOfBirth = new DateTime(1987, 10, 18),Address="XXXXXXXXX XXXX" });
            PersonsInfo.Add(new RecordInfo { Name = "JJ", Age = 21, DateOfBirth = new DateTime(1990, 11, 27),Address="XXXXX XXXXXXXX XX" });
        }

        public ObservableCollection<RecordInfo> PersonsInfo
        {
            get
            {
                return infos;
            }
            set
            {
                infos = value;
                OnPropertyChanged("PersonsInfo");
            }
        }

        public ICommand RemoveCommand
        {
            get
            {
                if (_command == null)
                {
                    _command = new DelegateCommand(CanExecute, Execute);
                }
                return _command;
            }
        }

        private void Execute(object parameter)
        {
            int index = PersonsInfo.IndexOf(parameter as RecordInfo);
            if (index > -1 && index < PersonsInfo.Count)
            {
                PersonsInfo.RemoveAt(index);
            }
        }

        private bool CanExecute(object parameter)
        {
            return true;
        }
    }
}
